<template lang="pug">
.control.is-flex.is-align-items-center
	.tags.has-addons( :class='sizeClass' )
		template( v-if='$slots.addon && addonPosition == "left"' )
			.tag.addon( :class='bindAddonClass' @click='emit("addonClick")' ): slot( name="addon" )
		.tag( :class='bindTagClass' @click='emit("click")' ): slot
		template( v-if='$slots.addon && addonPosition == "right"' )
			.tag.addon( :class='bindAddonClass' @click='emit("addonClick")' ): slot( name="addon" )
</template>

<script setup>
	import { computed } from "vue"

	const props = defineProps({
		type: String,
		addonType: {
			type: String,
			default: "danger"
		},
		addonPosition: {
			type: String,
			default: "right",
			validator: val => [ "right", "left" ].includes(val)
		},
		size: {
			type: String,
			default: "",
			validator: val => [ "", "small", "normal", "medium", "large" ].includes(val)
		},
		light: Boolean
	})
	const emit = defineEmits([ "click", "addonClick" ])

	const sizeClass = computed(() => [
		props.size ? `are-${props.size}` : ""
	])

	const bindTagClass = computed(() => [
		props.type ? `is-${props.type}` : "",
		props.light ? "is-light" : ""
	])

	const bindAddonClass = computed(() => [
		props.addonType ? `is-${props.addonType}` : ""
	])
</script>

<style lang="scss" scoped>
.addon {
	cursor: pointer;
	&:hover {
		filter: brightness(.9);
	}
}
</style>